package com.sd2group30.gamingwizard;

import java.util.ArrayList;

public class NPC implements Comparable {
    private String name;
    private int hp;
    private int current_hp;
    private int ac;
    private int speed;
    private int str_score;
    private int dex_score;
    private int con_score;
    private int int_score;
    private int wis_score;
    private int cha_score;
    private int challenge_score;
    private int exp_given;
    private ArrayList<String> npc_attack_buttons;
    private boolean player;
    private int initiative;
    private boolean turn;
    private String unique_character_id;
    private int character_x_coordinate, character_y_coordinate;

    public NPC(String name, int hp, int current_hp, int ac, int speed, int str_score, int dex_score, int con_score,
               int int_score, int wis_score, int cha_score, int challenge_score, int exp_given,
               ArrayList<String> npc_attack_buttons, boolean player, int initiative, boolean turn, String unique_character_id, int character_x_coordinate, int character_y_coordinate) {
        this.name = name;
        this.hp = hp;
        this.current_hp = current_hp;
        this.ac = ac;
        this.speed = speed;
        this.str_score = str_score;
        this.dex_score = dex_score;
        this.con_score = con_score;
        this.int_score = int_score;
        this.wis_score = wis_score;
        this.cha_score = cha_score;
        this.challenge_score = challenge_score;
        this.exp_given = exp_given;
        this.npc_attack_buttons = npc_attack_buttons;
        this.player = player;
        this.initiative = initiative;
        this.turn = turn;
        this.unique_character_id = unique_character_id;
        this.character_x_coordinate = character_x_coordinate;
        this.character_y_coordinate = character_y_coordinate;
    }

    public int getAc() {
        return ac;
    }

    public void setAc(int ac) {
        this.ac = ac;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getCon_score() {
        return con_score;
    }

    public void setCon_score(int con_score) {
        this.con_score = con_score;
    }

    public int getSpeed() {
        return speed;
    }

    public void setSpeed(int speed) {
        this.speed = speed;
    }

    public int getStr_score() {
        return str_score;
    }

    public void setStr_score(int str_score) {
        this.str_score = str_score;
    }

    public int getDex_score() {
        return dex_score;
    }

    public void setDex_score(int dex_score) {
        this.dex_score = dex_score;
    }

    public int getInt_score() {
        return int_score;
    }

    public void setInt_score(int int_score) {
        this.int_score = int_score;
    }

    public int getWis_score() {
        return wis_score;
    }

    public void setWis_score(int wis_score) {
        this.wis_score = wis_score;
    }

    public int getCha_score() {
        return cha_score;
    }

    public void setCha_score(int cha_score) {
        this.cha_score = cha_score;
    }

    public int getChallenge_score() {
        return challenge_score;
    }

    public void setChallenge_score(int challenge_score) {
        this.challenge_score = challenge_score;
    }

    public int getExp_given() {
        return exp_given;
    }

    public void setExp_given(int exp_given) {
        this.exp_given = exp_given;
    }

    public ArrayList<String> getNpc_attack_buttons() {
        return npc_attack_buttons;
    }

    public void setNpc_attack_buttons(ArrayList<String> npc_attack_buttons) {
        this.npc_attack_buttons = npc_attack_buttons;
    }

    @Override
    public int compareTo(Object o) {
        return 0;
    }

    public int getHp() {
        return hp;
    }

    public void setHp(int hp) {
        this.hp = hp;
    }

    public int getCurrent_hp() {
        return current_hp;
    }

    public void setCurrent_hp(int current_hp) {
        this.current_hp = current_hp;
    }

    public boolean isPlayer() {
        return player;
    }

    public void setPlayer(boolean player) {
        this.player = player;
    }

    public int getInitiative() {
        return initiative;
    }

    public void setInitiative(int initiative) {
        this.initiative = initiative;
    }

    public boolean isTurn() {
        return turn;
    }

    public void setTurn(boolean turn) {
        this.turn = turn;
    }

    public String getUnique_character_id() {
        return unique_character_id;
    }

    public void setUnique_character_id(String unique_character_id) {
        this.unique_character_id = unique_character_id;
    }

    public int getCharacter_x_coordinate() {
        return character_x_coordinate;
    }

    public void setCharacter_x_coordinate(int character_x_coordinate) {
        this.character_x_coordinate = character_x_coordinate;
    }

    public int getCharacter_y_coordinate() {
        return character_y_coordinate;
    }

    public void setCharacter_y_coordinate(int character_y_coordinate) {
        this.character_y_coordinate = character_y_coordinate;
    }
}
