package com.sd2group30.gamingwizard;

import java.util.ArrayList;

public class Player implements Comparable {
    private String character_name, character_race, character_class, bluetooth_id, action;
    private int character_level, character_ac_total, character_max_hp, character_current_hp, character_proficiency,
            character_str, character_str_mod, character_dex, character_dex_mod, character_con, character_con_mod,
            character_int, character_int_mod, character_wis, character_wis_mod, character_cha, character_cha_mod,
            character_speed;
    private boolean str_proficiency, dex_proficiency, con_proficiency, int_proficiency,
            wis_proficiency, cha_proficiency, acrobatics, animal_handling,
            arcana, athletics, deception, history, insight,
            intimidation, investigation, medicine, nature, perception,
            performance, persuasion, religion, sleight_of_hand,
            stealth, survival, character_turn;
    private ArrayList<String> attack_buttons, info_tab;
    private String unique_character_id;
    private int character_x_coordinate, character_y_coordinate;

    public Player(String character_name, String character_race, String character_class, String bluetooth_id, String action, int character_level, int character_ac_total, int character_max_hp, int character_current_hp, int character_proficiency, int character_str, int character_str_mod, int character_dex, int character_dex_mod, int character_con, int character_con_mod, int character_int, int character_int_mod, int character_wis, int character_wis_mod, int character_cha, int character_cha_mod, int character_speed, boolean str_proficiency, boolean dex_proficiency, boolean con_proficiency, boolean int_proficiency, boolean wis_proficiency, boolean cha_proficiency, boolean acrobatics, boolean animal_handling, boolean arcana, boolean athletics, boolean deception, boolean history, boolean insight, boolean intimidation, boolean investigation, boolean medicine, boolean nature, boolean perception, boolean performance, boolean persuasion, boolean religion, boolean sleight_of_hand, boolean stealth, boolean survival, boolean character_turn, ArrayList<String> attack_buttons, ArrayList<String> info_tab, String unique_character_id, int character_x_coordinate, int character_y_coordinate) {
        this.character_name = character_name;
        this.character_race = character_race;
        this.character_class = character_class;
        this.bluetooth_id = bluetooth_id;
        this.action = action;
        this.character_level = character_level;
        this.character_ac_total = character_ac_total;
        this.character_max_hp = character_max_hp;
        this.character_current_hp = character_current_hp;
        this.character_proficiency = character_proficiency;
        this.character_str = character_str;
        this.character_str_mod = character_str_mod;
        this.character_dex = character_dex;
        this.character_dex_mod = character_dex_mod;
        this.character_con = character_con;
        this.character_con_mod = character_con_mod;
        this.character_int = character_int;
        this.character_int_mod = character_int_mod;
        this.character_wis = character_wis;
        this.character_wis_mod = character_wis_mod;
        this.character_cha = character_cha;
        this.character_cha_mod = character_cha_mod;
        this.character_speed = character_speed;
        this.str_proficiency = str_proficiency;
        this.dex_proficiency = dex_proficiency;
        this.con_proficiency = con_proficiency;
        this.int_proficiency = int_proficiency;
        this.wis_proficiency = wis_proficiency;
        this.cha_proficiency = cha_proficiency;
        this.acrobatics = acrobatics;
        this.animal_handling = animal_handling;
        this.arcana = arcana;
        this.athletics = athletics;
        this.deception = deception;
        this.history = history;
        this.insight = insight;
        this.intimidation = intimidation;
        this.investigation = investigation;
        this.medicine = medicine;
        this.nature = nature;
        this.perception = perception;
        this.performance = performance;
        this.persuasion = persuasion;
        this.religion = religion;
        this.sleight_of_hand = sleight_of_hand;
        this.stealth = stealth;
        this.survival = survival;
        this.character_turn = character_turn;
        this.attack_buttons = attack_buttons;
        this.info_tab = info_tab;
        this.unique_character_id = unique_character_id;
        this.character_x_coordinate = character_x_coordinate;
        this.character_y_coordinate = character_y_coordinate;
    }

    public String getCharacter_name() {
        return character_name;
    }

    public void setCharacter_name(String character_name) {
        this.character_name = character_name;
    }

    public String getCharacter_race() {
        return character_race;
    }

    public void setCharacter_race(String character_race) {
        this.character_race = character_race;
    }

    public String getCharacter_class() {
        return character_class;
    }

    public void setCharacter_class(String character_class) {
        this.character_class = character_class;
    }

    public int getCharacter_level() {
        return character_level;
    }

    public void setCharacter_level(int character_level) {
        this.character_level = character_level;
    }

    public int getCharacter_ac_total() {
        return character_ac_total;
    }

    public void setCharacter_ac_total(int character_ac_total) {
        this.character_ac_total = character_ac_total;
    }

    public int getCharacter_max_hp() {
        return character_max_hp;
    }

    public void setCharacter_max_hp(int character_max_hp) {
        this.character_max_hp = character_max_hp;
    }

    public int getCharacter_current_hp() {
        return character_current_hp;
    }

    public void setCharacter_current_hp(int character_current_hp) {
        this.character_current_hp = character_current_hp;
    }

    public int getCharacter_proficiency() {
        return character_proficiency;
    }

    public void setCharacter_proficiency(int character_proficiency) {
        this.character_proficiency = character_proficiency;
    }

    public int getCharacter_str() {
        return character_str;
    }

    public void setCharacter_str(int character_str) {
        this.character_str = character_str;
    }

    public int getCharacter_str_mod() {
        return character_str_mod;
    }

    public void setCharacter_str_mod(int character_str_mod) {
        this.character_str_mod = character_str_mod;
    }

    public int getCharacter_dex() {
        return character_dex;
    }

    public void setCharacter_dex(int character_dex) {
        this.character_dex = character_dex;
    }

    public int getCharacter_dex_mod() {
        return character_dex_mod;
    }

    public void setCharacter_dex_mod(int character_dex_mod) {
        this.character_dex_mod = character_dex_mod;
    }

    public int getCharacter_con() {
        return character_con;
    }

    public void setCharacter_con(int character_con) {
        this.character_con = character_con;
    }

    public int getCharacter_con_mod() {
        return character_con_mod;
    }

    public void setCharacter_con_mod(int character_con_mod) {
        this.character_con_mod = character_con_mod;
    }

    public int getCharacter_int() {
        return character_int;
    }

    public void setCharacter_int(int character_int) {
        this.character_int = character_int;
    }

    public int getCharacter_int_mod() {
        return character_int_mod;
    }

    public void setCharacter_int_mod(int character_int_mod) {
        this.character_int_mod = character_int_mod;
    }

    public int getCharacter_wis() {
        return character_wis;
    }

    public void setCharacter_wis(int character_wis) {
        this.character_wis = character_wis;
    }

    public int getCharacter_wis_mod() {
        return character_wis_mod;
    }

    public void setCharacter_wis_mod(int character_wis_mod) {
        this.character_wis_mod = character_wis_mod;
    }

    public int getCharacter_cha() {
        return character_cha;
    }

    public void setCharacter_cha(int character_cha) {
        this.character_cha = character_cha;
    }

    public int getCharacter_cha_mod() {
        return character_cha_mod;
    }

    public void setCharacter_cha_mod(int character_cha_mod) {
        this.character_cha_mod = character_cha_mod;
    }

    public int getCharacter_speed() {
        return character_speed;
    }

    public void setCharacter_speed(int character_speed) {
        this.character_speed = character_speed;
    }

    public boolean isStr_proficiency() {
        return str_proficiency;
    }

    public void setStr_proficiency(boolean str_proficiency) {
        this.str_proficiency = str_proficiency;
    }

    public boolean isDex_proficiency() {
        return dex_proficiency;
    }

    public void setDex_proficiency(boolean dex_proficiency) {
        this.dex_proficiency = dex_proficiency;
    }

    public boolean isCon_proficiency() {
        return con_proficiency;
    }

    public void setCon_proficiency(boolean con_proficiency) {
        this.con_proficiency = con_proficiency;
    }

    public boolean isInt_proficiency() {
        return int_proficiency;
    }

    public void setInt_proficiency(boolean int_proficiency) {
        this.int_proficiency = int_proficiency;
    }

    public boolean isWis_proficiency() {
        return wis_proficiency;
    }

    public void setWis_proficiency(boolean wis_proficiency) {
        this.wis_proficiency = wis_proficiency;
    }

    public boolean isCha_proficiency() {
        return cha_proficiency;
    }

    public void setCha_proficiency(boolean cha_proficiency) {
        this.cha_proficiency = cha_proficiency;
    }

    public boolean isAcrobatics() {
        return acrobatics;
    }

    public void setAcrobatics(boolean acrobatics) {
        this.acrobatics = acrobatics;
    }

    public boolean isAnimal_handling() {
        return animal_handling;
    }

    public void setAnimal_handling(boolean animal_handling) {
        this.animal_handling = animal_handling;
    }

    public boolean isArcana() {
        return arcana;
    }

    public void setArcana(boolean arcana) {
        this.arcana = arcana;
    }

    public boolean isAthletics() {
        return athletics;
    }

    public void setAthletics(boolean athletics) {
        this.athletics = athletics;
    }

    public boolean isDeception() {
        return deception;
    }

    public void setDeception(boolean deception) {
        this.deception = deception;
    }

    public boolean isHistory() {
        return history;
    }

    public void setHistory(boolean history) {
        this.history = history;
    }

    public boolean isInsight() {
        return insight;
    }

    public void setInsight(boolean insight) {
        this.insight = insight;
    }

    public boolean isIntimidation() {
        return intimidation;
    }

    public void setIntimidation(boolean intimidation) {
        this.intimidation = intimidation;
    }

    public boolean isInvestigation() {
        return investigation;
    }

    public void setInvestigation(boolean investigation) {
        this.investigation = investigation;
    }

    public boolean isMedicine() {
        return medicine;
    }

    public void setMedicine(boolean medicine) {
        this.medicine = medicine;
    }

    public boolean isNature() {
        return nature;
    }

    public void setNature(boolean nature) {
        this.nature = nature;
    }

    public boolean isPerception() {
        return perception;
    }

    public void setPerception(boolean perception) {
        this.perception = perception;
    }

    public boolean isPerformance() {
        return performance;
    }

    public void setPerformance(boolean performance) {
        this.performance = performance;
    }

    public boolean isPersuasion() {
        return persuasion;
    }

    public void setPersuasion(boolean persuasion) {
        this.persuasion = persuasion;
    }

    public boolean isReligion() {
        return religion;
    }

    public void setReligion(boolean religion) {
        this.religion = religion;
    }

    public boolean isSleight_of_hand() {
        return sleight_of_hand;
    }

    public void setSleight_of_hand(boolean sleight_of_hand) {
        this.sleight_of_hand = sleight_of_hand;
    }

    public boolean isStealth() {
        return stealth;
    }

    public void setStealth(boolean stealth) {
        this.stealth = stealth;
    }

    public boolean isSurvival() {
        return survival;
    }

    public void setSurvival(boolean survival) {
        this.survival = survival;
    }

    public boolean isCharacter_turn() {
        return character_turn;
    }

    public void setCharacter_turn(boolean character_turn) {
        this.character_turn = character_turn;
    }

    public ArrayList<String> getAttack_buttons() {
        return attack_buttons;
    }

    public void setAttack_buttons(ArrayList<String> attack_buttons) {
        this.attack_buttons = attack_buttons;
    }

    public ArrayList<String> getInfo_tab() {
        return info_tab;
    }

    public void setInfo_tab(ArrayList<String> info_tab) {
        this.info_tab = info_tab;
    }

    @Override
    public int compareTo(Object o) {
        return 0;
    }


    public String getAction() {
        return action;
    }

    public void setAction(String action) {
        this.action = action;
    }

    public String getBluetooth_id() {
        return bluetooth_id;
    }

    public void setBluetooth_id(String bluetooth_id) {
        this.bluetooth_id = bluetooth_id;
    }

    public String getUnique_character_id() {
        return unique_character_id;
    }

    public void setUnique_character_id(String unique_character_id) {
        this.unique_character_id = unique_character_id;
    }

    public int getCharacter_y_coordinate() {
        return character_y_coordinate;
    }

    public void setCharacter_y_coordinate(int character_y_coordinate) {
        this.character_y_coordinate = character_y_coordinate;
    }

    public int getCharacter_x_coordinate() {
        return character_x_coordinate;
    }

    public void setCharacter_x_coordinate(int character_x_coordinate) {
        this.character_x_coordinate = character_x_coordinate;
    }
}
